package com.badbuta.learnspringbootrestfulsqlite;

import org.springframework.web.bind.annotation.RestController;

import com.badbuta.learnspringbootrestfulsqlite.entities.User;
import com.google.gson.Gson;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.IOException;
import java.util.List;
import java.io.Reader;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;

/**
 * The RESTful API Controller Class
 * The URL for this API Controller is '/api/v1'
 * 
 * NOTE: By adding @CrossOrigin, Swagger preview can work perfectly.
 * 
 */
@RestController
@CrossOrigin
@RequestMapping(value = "/api/v1")
public class ApiController {

    @Value("${mybatis.config-location}")
    private String myBatisConfigLocation;

    /**
     * API Endpoint = /api (or /api/)
     * 
     * @return Simple text
     */
    @RequestMapping(value = { "", "/" }, method = RequestMethod.GET)
    @ResponseBody
    public String getRoot() {
        // TODO: it is not a good practice and should return formatted JSON object
        return "This is API root";
    }

    // @GetMapping("/test")
    // public String getTest(@RequestParam(name = "a", required = false) String
    // valA) {
    // return "GET /test, param: a=" + valA;
    // }

    @GetMapping("fix")
    public String getUsers() {
        Gson gson = new Gson();

        String myBatisConfigPath = myBatisConfigLocation.split(":")[1];

        try (Reader in = Resources.getResourceAsReader(myBatisConfigPath)) {
            // Create SQL Session Factory from mybatis config
            SqlSessionFactory factory = new SqlSessionFactoryBuilder().build(in);

            // Create session
            SqlSession session = factory.openSession();

            // Select users
            List<User> result = session
                    .selectList("com.badbuta.learnspringbootrestfulsqlite.mapper.UserMapper.getUsers");

            return gson.toJson(result);

        } catch (IOException e) {
            // If exception, return the exception object in JSON
            // TODO: it is not a good practice and should return formatted error object
            System.err.println(e);
            return gson.toJson(e);
        }

    }
}
